<?php
namespace Geral\Repositories;

class Propostafas extends \Doctrine\ORM\EntityRepository
{  
    public function anoAnteriorPosterior($mesReajuste, $dataAceite){
        $sql = "SELECT
                   ADD_MONTHS(TO_DATE('01/'||:P_MESREAJ ||'/'||SUBSTR(TO_CHAR(:P_DTACEITE), 7, 4)), -12)  AS DTANOANT,
                   ADD_MONTHS(TO_DATE('01/'||:P_MESREAJ ||'/'||SUBSTR(TO_CHAR(:P_DTACEITE), 7, 4)), 0) AS DATA,
                   ADD_MONTHS(TO_DATE('01/'||:P_MESREAJ ||'/'||SUBSTR(TO_CHAR(:P_DTACEITE), 7, 4)), 0) - 1 AS DTANO,
                   ADD_MONTHS(TO_DATE('01/'||:P_MESREAJ ||'/'||SUBSTR(TO_CHAR(:P_DTACEITE), 7, 4)), 12) - 1  AS DTANOPOS,
                   SUBSTR(TO_CHAR(:P_DTACEITE), 4, 2) AS MES
                FROM
                   DUAL";

        $params = array(
            "P_MESREAJ"   => $mesReajuste,
            "P_DTACEITE"   => $dataAceite
        );

        $result = $this->_em->getConnection()->fetchArray($sql, $params);

        return $result;
    }

    public function checkPrimeiroAceiteCliente($inscricao){
        $sql = "SELECT CDCLIENTE
                  FROM PROPOSTAFAS
                 WHERE CDCLIENTE = :CDCLIENTE
                HAVING COUNT(DTACEPROPFAS) = 0
                 GROUP BY CDCLIENTE";

        $params = array(
            "CDCLIENTE"   => $inscricao
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return count($result) > 0 ? $result : false;
    }

    public function copiaProposta($proposta, $versao){
        $sql = "SELECT DISTINCT PR.NRPROPOSFAS, PR.NRVERPROPFAS, PR.DTPROPOSFAS,
                       PR.CDOPERINCL, PR.IDCLIENPROSP, TO_CHAR(TO_NUMBER(PR.NRCONTATO)) AS NRCONTATO,
                       PR.CDPROSPECT, PR.DTVALPROPFAS, PR.DTACEPROPFAS,
                       PR.DSEMAIPROFAS, PR.CDFILIAL, PR.CDCLIENTE,
                       PR.NRFAXPROPFAS, PR.DSOBSPROPFAS, PR.IDSOLPROPFAS,
                       OP.CDOPERADOR, OP.NMOPERADOR, PR.CDOPERSOLI,
                       O1.NMOPERADOR AS OPERSOLI, CN.DSREFECONT, CL.IDTPIJURCLIE,
                       PP.IDTPIJURPROS, CN.IDTPCONTATO, PR.CDTPINDICE1,
                       PR.IDPERVALOR1, PR.CDINDICE1, PR.VRPEINCIND1,
                       PR.CDTPINDICE2, PR.IDPERVALOR2, PR.CDINDICE2,
                       PR.NRMESREAJPROP, PR.CDOPERRESP, PR.IDLIBERAAGENDAMENTO,
                       PR.VRPEINCIND2, PR.IDTPREAJPROP, A.NMINDICE AS NMINDICEREAJ1, B.NMINDICE AS NMINDICEREAJ2,
                       DECODE(CL.CDCLIENTE, '', PP.CDPROSPECT, CL.CDCLIENTE) AS CODIGO,
                       DECODE(CL.NRINSJURCLIE, '', PP.NRINSJURPROS, CL.NRINSJURCLIE) AS NRINSJURCLIE,
                       DECODE(CL.NMFANTCLIE, '', PP.NMFANTPROS, CL.NMFANTCLIE) AS NOME, PR.DSREFEPROPOSFAS,
                       PR.CDINTECLIE, PR.CDINTEPROS, PR.IDTIPOPROPFAS, PR.CDPROCOMERCI, PR.IDTIPOCOBRSERV, PR.VRPACOTESERV
                  FROM PROPOSTAFAS PR, CLIENTE CL, OPERADOR OP, OPERADOR O1, PROSPECT PP,
                       CONTATO CN, INDICE A, INDICE B
                 WHERE (PR.NRPROPOSFAS = :P_NRPROPOSFAS)
                   AND (PR.NRVERPROPFAS = :P_NRVERPROPFAS)
                   AND (PR.CDOPERINCL = OP.CDOPERADOR)
                   AND (PR.CDOPERSOLI = O1.CDOPERADOR)
                   AND (PR.NRCONTATO = CN.NRCONTATO(+))
                   AND (PR.CDPROSPECT = PP.CDPROSPECT(+))
                   AND (PR.CDTPINDICE1 = A.CDTPINDICE(+))
                   AND (PR.CDINDICE1 = A.CDINDICE(+))
                   AND (PR.CDTPINDICE2 = B.CDTPINDICE(+))
                   AND (PR.CDINDICE2 = B.CDINDICE(+))
                   AND (PR.CDCLIENTE = CL.CDCLIENTE(+))
                ORDER BY NRPROPOSFAS";

        $params = array(
            "P_NRPROPOSFAS"   => $proposta,
            "P_NRVERPROPFAS"   => $versao
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return $result;
    }
    
    public function consultaDadosImprimirProposta($proposta, $versao, $filial)
    {
        $sql = "SELECT DISTINCT
                    PR.NRPROPOSFAS , PR.NRVERPROPFAS, PR.DTPROPOSFAS , PR.DTVALPROPFAS, PR.DTACEPROPFAS,       
                    NVL(PR.DSEMAIPROFAS, DECODE(ECL.DSEMAILCLIE, '', EPP.DSEMAILPROS, ECL.DSEMAILCLIE)) AS DSEMAIPROFAS,
                    NVL(PR.NRFAXPROPFAS, DECODE(ECL.NRFAXCLIE, '', EPP.NRFAXPROS,ECL.NRFAXCLIE)) AS NRFAXPROPFAS,
                    OP.NMOPERADOR  , O1.NMOPERADOR AS OPERSOLI, CN.DSREFECONT,
                    PR.VRPEINCIND1, PR.VRPEINCIND2, O2.NMOPERADOR AS NMOPERRESP,
                    PR.DSREFEPROPOSFAS, A.NMINDICE AS NMINDICEREAJ1, B.NMINDICE AS NMINDICEREAJ2,
                    PC.NMPROCOMERCI, PR.IDTPREAJPROP, PR.IDTIPOPROPFAS, PR.NRMESREAJPROP,
                    DECODE(CL.NRINSJURCLIE, '', PP.NRINSJURPROS, CL.NRINSJURCLIE) AS NRINSJURCLIE,
                    DECODE(CL.NMFANTCLIE, '', PP.NMFANTPROS, CL.NMFANTCLIE) AS NOMEFANTASIA,
                    DECODE(CL.NMRAZSOCCLIE, '', PP.NMRAZSOCPROS, CL.NMRAZSOCCLIE) AS RAZAOSOCIAL,
                    DECODE(IC.NMINTECLIE, '', IP.NMINTEPROS, IC.NMINTECLIE) AS NMINTECLIE,
                    DECODE(ECL.DSENDECLIE, '', EPP.DSENDEPROS, ECL.DSENDECLIE) AS ENDERECO,
                    DECODE(P1.NMPAIS, '' ,P2.NMPAIS, P1.NMPAIS) AS PAIS,
                    DECODE(E1.SGESTADO, '', E2.SGESTADO, E1.SGESTADO) AS SGESTADO,
                    DECODE(E1.NMESTADO, '', E2.NMESTADO, E1.NMESTADO) AS ESTADO,
                    DECODE(M1.NMMUNICIPIO, '', M2.NMMUNICIPIO, M1.NMMUNICIPIO) AS MUNICIPIO,
                    DECODE(B1.NMBAIRRO, '', EPP.NMBAIRPROS, B1.NMBAIRRO) AS BAIRRO,
                    DECODE(ECL.NRCEPCLIE, '', EPP.NRCEPPROS, ECL.NRCEPCLIE) AS CEP,
                    DECODE(ECL.NRTELECLIE, '', EPP.NRTELEPROS, ECL.NRTELECLIE) AS TEL,
                    DECODE(ECL.NRTELRESICLI, '', EPP.NRTELRESIPRO, ECL.NRTELRESICLI) AS RESIDENCIAL
               FROM PROPOSTAFAS PR, CLIENTE CL, ENDECLIE ECL, OPERADOR OP, OPERADOR O1,
                    OPERADOR O2, PROSPECT PP   , ENDEPROSPECT EPP, CONTATO CN, INDICE A,
                    INDICE B, INTECLIE IC, INTEPROSP IP, PROCOMERCI PC, PAIS P1, PAIS P2,
                    ESTADO E1, ESTADO E2, MUNICIPIO M1, MUNICIPIO M2, BAIRRO B1
              WHERE (PR.CDFILIAL      = :P_CDFILIAL     )
                AND (PR.NRPROPOSFAS   = :P_NRPROPOSFAS  )
                AND (PR.NRVERPROPFAS  = :P_NRVERPROPFAS )
                AND (PR.CDOPERINCL    = OP.CDOPERADOR   )
                AND (PR.CDFILIAL      = CN.CDFILIAL(+)  )
                AND (PR.NRCONTATO     = CN.NRCONTATO(+) )
                AND (PR.CDOPERSOLI    = O1.CDOPERADOR   )
                AND (PR.CDOPERRESP    = O2.CDOPERADOR(+))
                AND (PR.CDTPINDICE1   = A.CDTPINDICE (+))
                AND (PR.IDPERVALOR1   = A.IDPERVALOR (+))
                AND (PR.CDINDICE1     = A.CDINDICE   (+))
                AND (PR.CDTPINDICE2   = B.CDTPINDICE (+))
                AND (PR.IDPERVALOR2   = B.IDPERVALOR (+))
                AND (PR.CDINDICE2     = B.CDINDICE   (+))
                AND (PR.CDOPERINCL    = OP.CDOPERADOR   )
                AND (PR.CDCLIENTE     = CL.CDCLIENTE(+) )
                AND (PR.CDCLIENTE     = IC.CDCLIENTE(+) )
                AND (PR.CDINTECLIE    = IC.CDINTECLIE(+))
                AND (PR.CDPROSPECT    = PP.CDPROSPECT(+))
                AND (PR.CDPROSPECT    = IP.CDPROSPECT(+))
                AND (PR.CDINTEPROS    = IP.CDINTEPROS(+))
                AND (CL.CDCLIENTE     = ECL.CDCLIENTE(+))
                AND (PP.CDPROSPECT    = EPP.CDPROSPECT(+))
                AND (ECL.CDPAIS       = P1.CDPAIS(+))
                AND (EPP.CDPAIS       = P2.CDPAIS(+))
                AND (ECL.CDPAIS       = E1.CDPAIS(+))
                AND (ECL.SGESTADO     = E1.SGESTADO(+))
                AND (EPP.CDPAIS       = E2.CDPAIS(+))
                AND (EPP.SGESTADO     = E2.SGESTADO(+))
                AND (ECL.CDPAIS       = M1.CDPAIS(+))
                AND (ECL.SGESTADO     = M1.SGESTADO(+))
                AND (ECL.CDMUNICIPIO  = M1.CDMUNICIPIO(+))
                AND (EPP.CDPAIS       = M2.CDPAIS(+))
                AND (EPP.SGESTADO     = M2.SGESTADO(+))
                AND (EPP.CDMUNICIPIO  = M2.CDMUNICIPIO(+))
                AND (ECL.CDPAIS       = B1.CDPAIS(+))
                AND (ECL.SGESTADO     = B1.SGESTADO(+))
                AND (ECL.CDMUNICIPIO  = B1.CDMUNICIPIO(+))
                AND (ECL.CDBAIRRO     = B1.CDBAIRRO(+))
                AND (PR.CDPROCOMERCI  = PC.CDPROCOMERCI(+))
                AND (ECL.IDTPENDECLIE(+) = 'P')
                AND (EPP.IDTPENDEPROS(+) = 'P')
              ORDER BY NRPROPOSFAS, NRVERPROPFAS";

        $params = array(
            "P_NRPROPOSFAS"  => $proposta,
            "P_NRVERPROPFAS" => $versao,
            "P_CDFILIAL"     => $filial
        );

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }    
    
    public function consultaProxCodigoProposta()
    {
      //SUBSTR pois existia números de propostas no banco com 11 Caracteres, sendo que o limite é 10!
        $sql = "SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(SUBSTR(NRPROPOSFAS, 0, 10))), 0)+1, '0000000009')) AS NRPROPOSFAS
                FROM PROPOSTAFAS";
                
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function consultaProxCodigoVersaoProposta($nrProposta, $nrOrg)
    {
        $sql = "SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(NRVERPROPFAS)), 0)+1, '09')) AS NRVERPROPFAS
                FROM PROPOSTAFAS
               WHERE NRPROPOSFAS = :NRPROPOSFAS
                 AND NRORG       = :NRORG";
        
        $params = array(
            "NRPROPOSFAS" => $nrProposta,
            "NRORG"       => $nrOrg
        );
        
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function consultaCdSegMerLinP($nrProposta, $nrVersao, $idClienProsp)
    {
        if($idClienProsp == 'P')
        {
            $sql = "SELECT PRO.CDSEGMER
                      FROM PROPOSTAFAS PPT, PROSPECT PRO 
                     WHERE PPT.NRPROPOSFAS  = :NRPROPOSFAS 
                       AND PPT.NRVERPROPFAS = :NRVERPROPFAS
                       AND PPT.CDPROSPECT   = PRO.CDPROSPECT(+)";
        }
        
        else
        {
            $sql = "SELECT CLI.CDSEGMER
                      FROM PROPOSTAFAS PPT, CLIENTE CLI
                     WHERE PPT.NRPROPOSFAS  = :NRPROPOSFAS 
                       AND PPT.NRVERPROPFAS = :NRVERPROPFAS 
                       AND PPT.CDCLIENTE    = CLI.CDCLIENTE(+)";
        }
        
        $params = array(
                        "NRPROPOSFAS" => $nrProposta,
                        "NRVERPROPFAS" => $nrVersao
                       );

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
        
    public function mnemonicoSoliRev($nrProposta, $nrVersao) 
    {
        $sql = "SELECT CARGOSOLI.NMCARGO AS NMCARGOOPERSOLI, GERENTE.NMGEROPERSOLI, GERENTE.NMCARGEROPERSOLI, CARGINTERLOC.NMCARGOINTERLOC,
                        REVENDA.NMFANTCLIEREV, REVENDA.NMRAZSOCCLIEREV, REVENDA.NMINTECLIREV, REVENDA.NMCARGOINTECLIREV, GERENTE.NRCPFGERSOLI
                   FROM PROPOSTAFAS PR, CARGO CARGOSOLI, OPERADOR OP, FUNCIONARIO F,
                        (SELECT MAX(OG.NMOPERADOR) AS NMGEROPERSOLI, MAX(CG.NMCARGO) AS NMCARGEROPERSOLI, MAX(FG.NRCPFFUNC) AS NRCPFGERSOLI
                           FROM  CARGO CG, FUNCIONARIO FG, OPERADOR OG, EQUIPETRAB EQ,
                                 FUNCIONARIO FS, OPERADOR OS, PROPOSTAFAS PR
                          WHERE PR.NRPROPOSFAS = :P_NRPROPOSFAS
                            AND PR.NRVERPROPFAS = :P_NRVERPROPFAS
                            AND OS.CDOPERADOR = PR.CDOPERSOLI
                            AND FS.CDFUNC = OS.CDFUNC
                            AND FS.CDEMPRESA = OS.CDEMPRESA
                            AND EQ.CDEQUIPETRAB = FS.CDEQUIPETRAB
                            AND OG.CDOPERADOR = EQ.CDOPERRESP
                            AND FG.CDFUNC = OG.CDFUNC
                            AND FG.CDEMPRESA = OG.CDEMPRESA
                            AND CG.CDCARGO = FG.CDCARGO) GERENTE,
                        (SELECT MAX(NMCARGOINTERLOC) AS NMCARGOINTERLOC
                           FROM
                        (SELECT MAX(CI.NMCARGOINTERLOC) AS NMCARGOINTERLOC
                           FROM INTECLIE IC, CARGOINTERLOC CI, PROPOSTAFAS PR
                          WHERE PR.NRPROPOSFAS = :P_NRPROPOSFAS
                            AND PR.NRVERPROPFAS = :P_NRVERPROPFAS
                            AND IC.CDCLIENTE = PR.CDCLIENTE
                            AND IC.CDINTECLIE = PR.CDINTECLIE
                            AND IC.CDCARGOINTERLOC = CI.CDCARGOINTERLOC
                          UNION
                         SELECT MAX(IP.DSCARGINPROS) AS NMCARGOINTERLOC
                           FROM INTEPROSP IP, PROPOSTAFAS PR
                          WHERE PR.NRPROPOSFAS = :P_NRPROPOSFAS
                            AND PR.NRVERPROPFAS = :P_NRVERPROPFAS
                            AND IP.CDPROSPECT = PR.CDPROSPECT
                            AND IP.CDINTEPROS = PR.CDINTEPROS)) CARGINTERLOC,
                        (SELECT MAX(CL.NMFANTCLIE) AS NMFANTCLIEREV, MAX(CL.NMRAZSOCCLIE) AS NMRAZSOCCLIEREV,
                                MAX(INTERLOC.NMINTECLIE) AS NMINTECLIREV, MAX(INTERLOC.NMCARGOINTERLOC) AS NMCARGOINTECLIREV
                           FROM CLIENTE CL, PROPOSTAFAS PR,
                                (SELECT MAX(IT.NMINTECLIE) AS NMINTECLIE, MAX(CI.NMCARGOINTERLOC) AS NMCARGOINTERLOC
                                   FROM INTECLIE IT, PROPOSTAFAS PR, CARGOINTERLOC CI
                                  WHERE PR.CDINTECLIEREVENDA = IT.CDCLIENTE
                                    AND PR.CDINTECLIEREVENDA = IT.CDINTECLIE
                                    AND CI.CDCARGOINTERLOC = IT.CDCARGOINTERLOC(+)) INTERLOC
                          WHERE PR.NRPROPOSFAS = :P_NRPROPOSFAS
                            AND PR.NRVERPROPFAS = :P_NRVERPROPFAS
                            AND CL.CDCLIENTE = PR.CDCLIENTEREVENDA) REVENDA
                  WHERE PR.CDOPERSOLI = OP.CDOPERADOR
                    AND CARGOSOLI.CDCARGO = F.CDCARGO
                    AND PR.NRPROPOSFAS = :P_NRPROPOSFAS
                    AND PR.NRVERPROPFAS = :P_NRVERPROPFAS
                    AND F.CDFUNC = OP.CDFUNC
                    AND F.CDEMPRESA = OP.CDEMPRESA";

        $params = array(
            "P_NRPROPOSFAS"  => $nrProposta,
            "P_NRVERPROPFAS" => $nrVersao
        );

        try {
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function disableEnableTriggerAceite($triggerName, $idEnableDisable) 
    {
        //Altera a Trigger escolhida para o modo selecionado ('ENABLE' / 'DISABLE')
        $sql = "ALTER TRIGGER ".$triggerName." ".$idEnableDisable;
        
        try {
            return $this->_em->getConnection()->executeQuery($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function verificaTriggerAceite($triggerName)
    {
        //VERIFICA SE EXISTE A TRIGGER PASSADA POR PARAMETRO NO BANCO DE DADOS
        $sql = "SELECT COUNT(*) AS COUNTTRIGGER, NVL(MAX(STATUS), 'DISABLED') AS STATUS
                  FROM USER_TRIGGERS
                 WHERE TRIGGER_NAME = '$triggerName'
                   AND STATUS = 'ENABLED'";
        
        try {
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}