<?php
namespace Teknisa\Model\Geral\Repositories;


class Municipio extends \Doctrine\ORM\EntityRepository {

    public function obtemPorSiglaEstado($sigla, $conditions = " "){
        $query = "
        SELECT *
		  FROM ( SELECT M.CDMUNICIPIO, M.NMMUNICIPIO, M.SGESTADO AS STATE_SYMBOL
                   FROM MUNICIPIO M
                  WHERE M.SGESTADO = :sigla
               ORDER BY M.NMMUNICIPIO )
         WHERE 1=1
		 $conditions
        ";

        $params = array(
            "sigla" => $sigla
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return ($result) ? $result : array();
    }

    public function obtemPorSiglasEstados($siglas, $conditions = " "){
        $query = "
        SELECT *
		  FROM ( SELECT M.CDMUNICIPIO, M.NMMUNICIPIO, M.SGESTADO AS STATE_SYMBOL
                   FROM MUNICIPIO M
                  WHERE M.SGESTADO IN ($siglas)
               ORDER BY M.NMMUNICIPIO )
         WHERE 1=1
		 $conditions
        ";

        $result = $this->getEntityManager()->getConnection()->fetchAll($query);
        return ($result) ? $result : array();
    }

    public function getCity($sigla, $countryId, $conditions = " "){
        $query = "
        SELECT *
		  FROM ( SELECT M.CDMUNICIPIO, M.NMMUNICIPIO, M.SGESTADO AS STATE_SYMBOL
                   FROM MUNICIPIO M
                  WHERE M.SGESTADO = :sigla
		            AND M.CDPAIS = :CDPAIS
               ORDER BY M.NMMUNICIPIO )
         WHERE 1=1
		 $conditions
        ";

        $params = array(
            "sigla" => $sigla,
            "CDPAIS" => $countryId
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return ($result) ? $result : array();
    }

    public function getCityNameLike($sigla, $countryId, $nmmunicipio){
        $query = "
        SELECT M.CDMUNICIPIO, M.NMMUNICIPIO, M.SGESTADO
          FROM MUNICIPIO M
         WHERE M.SGESTADO = :sigla
           AND M.CDPAIS = :CDPAIS
           AND UPPER(M.NMMUNICIPIO) LIKE '%$nmmunicipio%'";

        $params = ["sigla" => $sigla,
                   "CDPAIS" => $countryId];

        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return ($result) ? $result : [];
    }
}
